Program Project1;
(* -------------------------------------------------------- *)
Type
  Dword = Cardinal;

  SIZE = Record
    Height: Word;
    Width : Word;
  End;
(* -------------------------------------------------------- *)
Const
 (* Window styles *)
  WS_SKINNED_FIXED    =  $4000000;
  WS_SKINNED_SIZABLE  =  $3000000;
  WS_FIXED            =  $0000000;
  WS_SIZABLE          =  $2000000;
  WS_FILL_TRANSPARENT = $40000000;
  WS_FILL_GRADIENT    = $80000000;
  WS_COORD_CLIENT     = $20000000;
  WS_CAPTION          = $10000000;

 (* Caption styles *)
  CAPTION_MOVABLE     = $00000000;
  CAPTION_NONMOVABLE  = $01000000;

 (* Events *)
  REDRAW_EVENT        = 1;
  KEY_EVENT           = 2;
  BUTTON_EVENT        = 3;
  MOUSE_EVENT         = 6;

 (* Colors *)
  COLOR_BLUE          = $000000FF;
  COLOR_RED           = $00FF0000;
  COLOR_GREEN         = $0000FF00;
  COLOR_WHITE         = $00FFFFFF;
  COLOR_BLACK         = $00000000;

  sz_hello  = AnsiString('Hello, Delphi 7.0!');
(* -------------------------------------------------------- *)
Var
  Left, Top, Right, Bottom: Integer;
  Scr: SIZE;
(* -------------------------------------------------------- *)
Procedure Main; Forward;
Procedure BeginDraw; Forward;
Procedure EndDraw; Forward;
Procedure DrawWindow(Left, Top, Right, Bottom: Integer; Caption: PChar; BackColor, Style, CapStyle: Dword); StdCall; Forward;
Procedure ThreadTerminate; Forward;
Procedure On_Redraw; Forward;
Procedure On_Key; Forward;
Procedure On_Button; Forward;
Function  WaitEvent: Dword; Forward;
Function  GetKey: Dword; Forward;
Function  GetButton: Dword; Forward;
Function  GetScreenSize: SIZE; Forward;
(* -------------------------------------------------------- *)
Procedure Main();
Begin
  Scr := GetScreenSize();

  Right  := Scr.Width  Shr 2;
  Bottom := Scr.Height Shr 2;
  Left   := (Scr.Width  - Right)  Shr 1;
  Top    := (Scr.Height - Bottom) Shr 1;

  While TRUE Do Begin
    Case WaitEvent() Of
    REDRAW_EVENT : On_Redraw;
    KEY_EVENT    : On_Key;
    BUTTON_EVENT : On_Button;
    End;
  End;
End;
(* -------------------------------------------------------- *)
Procedure On_Redraw();
Begin
 BeginDraw;
 DrawWindow(Left, Top, Right, Bottom, sz_hello, COLOR_WHITE, WS_SKINNED_FIXED + WS_COORD_CLIENT + WS_CAPTION, CAPTION_MOVABLE);
 EndDraw;
End;
(* -------------------------------------------------------- *)
Procedure On_Key();
Begin
  GetKey;
End;
(* -------------------------------------------------------- *)
Procedure On_Button();
Begin
  Case GetButton() Shr 8 Of
  1 : ThreadTerminate;
  End;
End;
(* -------------------------------------------------------- *)
Procedure BeginDraw();
Asm
        push   ebx
        mov    eax, 12
        mov    ebx, 1
        int    64
        pop    ebx
End;
(* -------------------------------------------------------- *)
Procedure EndDraw();
Asm
        push   ebx
        mov    eax, 12
        mov    ebx, 2
        int    64
        pop    ebx
End;
(* -------------------------------------------------------- *)
Procedure DrawWindow(Left, Top, Right, Bottom: Integer; Caption: PChar; BackColor, Style, CapStyle: Dword);
Asm
        push   ebx
        push   edi
        push   esi
        xor    eax, eax
        mov    ebx, Left
        shl    ebx, 16
        add    ebx, Right
        mov    ecx, Top
        shl    ecx, 16
        add    ecx, Bottom
        mov    edx, Style
        or     edx, BackColor
        mov    edi, Caption
        mov    esi, CapStyle
        int    64
        pop    esi
        pop    edi
        pop    ebx
End;
(* -------------------------------------------------------- *)
Function WaitEvent(): Dword;
Asm
        mov    eax, 10
        int    64
End;
(* -------------------------------------------------------- *)
Function GetKey(): Dword;
Asm
        mov    eax, 2
        int    64
End;
(* -------------------------------------------------------- *)
Function GetButton(): Dword;
Asm
        mov    eax, 17
        int    64
End;
(* -------------------------------------------------------- *)
Procedure ThreadTerminate();
Asm
        mov    eax, $FFFFFFFF;
        int    64
End;
(* -------------------------------------------------------- *)
Function GetScreenSize(): SIZE;
Asm
        push   ebx
        mov    eax, 61
        mov    ebx, 1
        int    64
        pop    ebx
End;
(* -------------------------------------------------------- *)
Begin Main; end.
